Bug 627788 - slip.util.files.overwrite_safely fails when SELinux is disabled
Summary: slip.util.files.overwrite_safely fails when SELinux is disabled
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: python-slip
Version: 13
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Nils Philippsen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 716391
TreeView+ depends on / blocked
 
Reported: 2010-08-27 00:33 UTC by Matt McCutchen
Modified: 2011-11-22 13:21 UTC (History)
2 users (show)

Fixed In Version: python-slip-0.2.13-1.fc13
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 716391 755939 (view as bug list)
Environment:
Last Closed: 2010-09-02 20:37:55 UTC


Attachments (Terms of Use)

Description Matt McCutchen 2010-08-27 00:33:10 UTC
Description of problem:
If SELinux is disabled, when slip.util.files.overwrite_safely is called with the default preserve_context=True, it fails because it cannot read the "security.selinux" xattr of the destination file.  This makes it impossible to save the configuration in system-config-date.

Version-Release number of selected component (if applicable):
python-slip-0.2.12-1.fc13.noarch

How reproducible:
Always

Steps to Reproduce:
touch foo
python <<SCRIPT
from slip.util.files import overwrite_safely
overwrite_safely("foo", "content")
SCRIPT
  
Actual results:
Traceback (most recent call last):
  File "<stdin>", line 2, in <module>
  File "/usr/lib/python2.6/site-packages/slip/util/files.py", line 179, in overwrite_safely
    ret, ctx = selinux.getfilecon(path)
OSError: [Errno 61] No data available

Expected results:
The file is successfully written.

Comment 1 Nils Philippsen 2010-08-31 13:47:57 UTC
I seem to have misunderstood the possible return values of selinux.is_selinux_enabled():

commit 6502bebb6b94d613e84e2cc517a299e2cb9028c9
Author: Nils Philippsen <nils@redhat.com>
Date:   Tue Aug 31 15:43:30 2010 +0200

    fix overwrite_safely() if SELinux is disabled (#627788)

diff --git a/slip/util/files.py b/slip/util/files.py
index b248d17..1b2887d 100644
--- a/slip/util/files.py
+++ b/slip/util/files.py
@@ -165,7 +165,7 @@ def overwrite_safely(path, content, preserve_mode=True, preserve_context=True):
 
     exists = os.path.exists(path)
 
-    if preserve_context and selinux.is_selinux_enabled() < 0:
+    if preserve_context and selinux.is_selinux_enabled() <= 0:
         preserve_context = False
 
     try:

Comment 2 Nils Philippsen 2010-08-31 13:54:56 UTC
According to your comment on the Fedora update page:

 mattmccutchen  - 2010-08-27 00:44:12
I'm unable to test bug 615819 because bug 627788 prevents system-config-date from saving the configuration at all on my SELinux-disabled system. I tried downgrading to python-slip-0.2.11-1.fc13 and the same problem occurs, so it's not a regression; I'm not sure what changed since I initially filed bug 615819.

It may even be that something changed in libselinux/-python (but that doesn't really matter now).

Comment 3 Fedora Update System 2010-08-31 14:48:14 UTC
python-slip-0.2.13-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/python-slip-0.2.13-1.fc14

Comment 4 Fedora Update System 2010-08-31 14:48:21 UTC
python-slip-0.2.13-1.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/python-slip-0.2.13-1.fc13

Comment 5 Fedora Update System 2010-08-31 14:48:26 UTC
python-slip-0.2.13-1.fc12 has been submitted as an update for Fedora 12.
https://admin.fedoraproject.org/updates/python-slip-0.2.13-1.fc12

Comment 6 Fedora Update System 2010-09-01 03:30:19 UTC
python-slip-0.2.13-1.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update python-slip'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/python-slip-0.2.13-1.fc13

Comment 7 Fedora Update System 2010-09-02 20:37:42 UTC
python-slip-0.2.13-1.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2010-10-01 12:25:06 UTC
python-slip-0.2.13-1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2010-10-08 20:39:15 UTC
python-slip-0.2.13-1.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.